<?php
/**
 * @package     IP Tracker Module for Joomla 3.6
 * @author		EdilWeb.eu
 *
 * @copyright   Copyright (C) 2016 Edilweb.eu
 * @license     GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
/* No direct access	*/
defined('_JEXEC') or die;


class ModIpTracker {
	static $IpTrack_output = '';
	static $continue = false;
}


class IPT_CAPTCHA {
    static $capFile = '';			/*	nome file captcha	*/
    static $good = '';				/*	messaggio per capthca	*/
    static $IPgood = '';			/*	messaggio per ip	*/
    static $IPtoTrack = '';			/*	ip da tracciare         */
    static $test_CaptchaStatus = '';		/*	esito del test captcha.		1 = nuovo;		2 = esito positivo;		3 = esito negativo;		4 = tentativi esauriti; 	*/
    static $test_GD = TRUE;			/*	supporto GD attivo	*/

    function __construct(){
        if (!isset($_SESSION['iptrack_digit_error'])){$_SESSION['iptrack_digit_error'] = 1;}

        $msg = JText::sprintf('MOD_IPTRACKER_INSERTIP', $_SERVER['REMOTE_ADDR']);

        self::$IPgood = $this->HTMLMsgGood($msg);

        /*	$_POST['inputIP']	*/
        $jinput = JFactory::getApplication()->input;
        $ip = $jinput->get('inputIP', '', 'STRING');
        if ($ip != ''){self::$IPtoTrack = $ip;} 

        $this->TestCaptcha();
    }	


    private function TestCaptcha(){
        /*	$_POST['inCaptcha']	*/
        $jinput = JFactory::getApplication()->input;
        $captcha = $jinput->get('inCaptcha', '', 'STRING');
		
        if ($captcha != null) {
            if ($_SESSION['iptrack_digit'] != $captcha){
                $_SESSION['iptrack_digit_error'] = $_SESSION['iptrack_digit_error'] + 1;
                if($this->Test_maxDigits() == true) {return ;}

                /*		$msg = 'Errore. Captcha errato';	*/
                $msg = JText::_('MOD_IPTRACKER_ERRCAPTC');	$color = 'red';
                self::$test_CaptchaStatus = 3;
            }
            else {
                $msg = '';	$color = 'green';
                self::$test_CaptchaStatus = 2;
            }
        }
        else {
            if($this->Test_maxDigits() == true) {return ;}
            /*		$msg = 'CAPTCHA';	*/
            $msg = JText::_('MOD_IPTRACKER__CAPTCHA');	$color = '';
            self::$test_CaptchaStatus = 1;
        }

        self::$good = $this->HTMLMsgGood($msg, $color);
    }	
	
    /**
     * Html msg esito IP o Captcha
     * @param  $msg string
     * @param  $color string
     * @return string
     */
    private function HTMLMsgGood($msg, $color=''){
        if (!$color){
            $htm = <<<HTM
<p><span>{$msg}</span></p>
HTM;
        }
        else {		
            $htm = <<<HTM
<p><span style="color:{$color};">{$msg}</span></p>
HTM;
        }
        return $htm;
    }

	/**
	 * Testa se IP inserito esiste ed è valido.
	 * Viene eseguita dopo che il captcha è stato superato.
	 * Quindi deve essere presente un valido IP.
	 * @return boolean	 */
    function Test_IP(){
    /*		$_POST['inputIP']	*/
        $jinput = JFactory::getApplication()->input;
        $ip = $jinput->get('inputIP', '', 'STRING');
		
        if ($ip != null){
            if (!filter_var($ip, FILTER_VALIDATE_IP) === false){
                /* valido, nulla	*/
                return true;
            }
            else {
                /* ip non valido */
                $msg = JText::_('MOD_IPTRACKER_ERRIPNOV');		$color = 'red';
                self::$IPgood = $this->HTMLMsgGood($msg, $color);
                return false;
            }
				
        }
        else {
            /* manca ip. inserisci un ip */
            $msg = JText::_('MOD_IPTRACKER_ERR_NOIP'); 
            $color = 'red';
            self::$IPgood = $this->HTMLMsgGood($msg, $color);
            return false;
        }
    }


    function GetCaptcha4(){
        /*
        Adapted for The Art of Web: www.the-art-of-web.com		
        Code adapted by www.edilweb.eu   october 2016
        Please acknowledge use of this code by including this header.
        */
        // initialise image with dimensions of 160 x 45 pixels
        //$image = @imagecreatetruecolor(160, 45) or die("Cannot Initialize new GD image stream");

        // initialise image with dimensions of 160 x 45 pixels
        if ($image = @imagecreatetruecolor(160, 45)) {

            // set background and allocate drawing colours
            $background = imagecolorallocate($image, 0x66, 0xCC, 0xFF);
            imagefill($image, 0, 0, $background);
            $linecolor = imagecolorallocate($image, 0x33, 0x99, 0xCC);
            $textcolor1 = imagecolorallocate($image, 0x00, 0x00, 0x00);
            $textcolor2 = imagecolorallocate($image, 0xFF, 0xFF, 0xFF);

            // draw random lines on canvas
            for($i=0; $i < 8; $i++) {
                    imagesetthickness($image, rand(1,3));
                    imageline($image, rand(0,160), 0, rand(0,160), 45, $linecolor);
            }

            // using a mixture of TTF fonts
            chdir(JPATH_BASE . '/modules/mod_iptracker');

            $fontpath = realpath('.');
            $gdBool = putenv('GDFONTPATH='. $fontpath);

            $fonts = array();
            $fonts[] = "DejaVuSerif-Bold.ttf";
            $fonts[] = "DejaVuSans-Bold.ttf";
            $fonts[] = "DejaVuSansMono-Bold.ttf";

            // add random digits to canvas using random black/white colour
            $digit = '';
            for($x = 10; $x <= 130; $x += 30) {
                $textcolor = (rand() % 2) ? $textcolor1 : $textcolor2;
                $digit .= ($num = rand(0, 9));
                imagettftext($image, 20, rand(-30,30), $x, rand(20, 42), $textcolor, $fonts[array_rand($fonts)], $num);
            }

            // record digits in session variable
            $_SESSION['iptrack_digit'] = $digit;

            // salva immagine e pulisce
            $captcha_file = 'cap/captcha_'.session_id().'.png';
            self::$capFile = '/modules/mod_iptracker/' . $captcha_file;

            imagepng($image, $captcha_file);		//	output su file $captcha_file

            imagedestroy($image);
        }
        else {
            self::$test_GD = false;
        }

    }
	
	
    function HTMLtoBrowser_noGD(){
        $info = JText::_('MOD_IPTRACKER_INFOV4V6');
        $stop = JText::_('MOD_IPTRACKER_GD_ERROR');
        $a = <<<HT
<div id="ed_captcha" class="edCaptcha">
<h3 class="ed_ipInfo">{$info}</h3>
<h3 class="capRed">{$stop}</h3>
</div>
HT;
		
        $this->Uscita($a);
    }


    function HTMtoBrowser_stop(){
        $info = JText::_('MOD_IPTRACKER_INFOV4V6');
        $stop = JText::_('MOD_IPTRACKER_STOPMORE');
        $a = <<<HT
<div id="ed_captcha" class="edCaptcha">
<h3 class="ed_ipInfo">{$info}</h3>
<h3 class="capRed">{$stop}</h3>
</div>
HT;

        $this->Uscita($a);
    }


    function HTMtoBrowser_captcha(){
        $ipGood = self::$IPgood;
        $good = self::$good;
        $capFile = self::$capFile;
        $ip = self::$IPtoTrack;

        $cpt   = JText::_('MOD_IPTRACKER_INFOV4V6');
        $copy  = JText::_('MOD_IPTRACKER_COPYCHAR');
        $sbmit = JText::_('MOD_IPTRACKER___SUBMIT');

        $uri = filter_input(INPUT_SERVER,'REQUEST_URI' );

//        if(preg_match('/\?/', $uri)){ $perUri = '&'; } else { $perUri = '?'; }
           /*  indirizzo per upload    */
//        $url = $uri . $perUri . 'download=on';

        $htm = <<<HT
<div id="ed_captcha" class="edCaptcha">
<h3 class="ed_ipInfo">{$cpt}</h3>
<form method="POST" action="{$uri}">
	{$ipGood}
	<p><input id="in_IP" class="inIP" name="inputIP" type="text" value="{$ip}" autofocus></p>
	{$good}
	<p><img src="{$capFile}" border="1" alt="CAPTCHA"></p>
	<p><input id="in_captcha" name="inCaptcha" type="text" value="" required><br>
	<span>{$copy}</span><span class="capRed">&nbsp;*</span></p>
	<p><input id="capSubmit" type="submit" value=" {$sbmit} "></p>
</form>
</div>
HT;
	
	$this->Uscita($htm);
	}


    private function Test_maxDigits(){
        if (isset($_SESSION['iptrack_digit_error']) && ($_SESSION['iptrack_digit_error'] > 10)){
            /*	Max tentativi per session esaurito	*/
            self::$test_CaptchaStatus = 4;
            return true;
        }
        return false;
    }

	
	/**
	 * $output  stringa inviata alla classe Joomla di passaggio per browser
	 * @param  $output string	 				 */
    private function Uscita($output) {
        ModIpTracker::$IpTrack_output = $output;
    }
}


class IPT_MAPVISITE_CAPTHA{
    private static $ipObj = '';			/*	risultato della richiesta a database	*/
    private static $IPtoTrack = '';		/*	ip da tracciare. La classe viene eseguita solo se un ip valido è presente	*/
    private static $ipQueryError = FALSE;       /*	Query database con errori	*/
    private static $sourceMaps;                 /*      che mappe   */
    private static $keyMap = '';		/*	key map for Google	*/

    function __construct(){
        /*	$_POST['inputIP']	*/
        $jinput = JFactory::getApplication()->input;
        $ip = $jinput->get('inputIP', '', 'STRING');
        self::$IPtoTrack = $ip;

        $this->Main();
    }

    private function Main(){
        /*	chiama ip-api.com	*/
        $httpQuery = "http://ip-api.com/json/" . self::$IPtoTrack;
        $ipResponse = file_get_contents($httpQuery);
		
		
        /*	test ip-api.com risponde?	*/
        if ($ipResponse == false){
            $this->HTMtoBrowser_noDb();
            self::$ipQueryError = true;
        }		

        /*	Trasforma in formato leggibile. Esce se il risultato è irregolare	*/
        if (!self::$ipQueryError) {
            $ipObj = json_decode($ipResponse);
            if($ipObj == null){
                $this->HTMtoBrowser_noDb();
                self::$ipQueryError = true;
            }
            else{
                self::$ipObj = $ipObj;
            }
        }
	
        /*	query fallisce per ip non trcciabile. Esce se irregolare	*/
        if (!self::$ipQueryError) {
            if (trim(self::$ipObj->status) == 'fail'){
                $this->HTMtoBrowser_failQuery();
                self::$ipQueryError = true;
            }
        }		

        /*	cerca host se esiste	*/
        if (!self::$ipQueryError) {
            $result = gethostbyaddr(self::$ipObj->query);
            /*	host oppure ip originale. false no perchè ip è già controllato	*/
            ($result == self::$ipObj->query) ? self::$ipObj->edhost = 'No Host' : self::$ipObj->edhost = $result;
        }
	
        /*	test bakend data	*/
        if (!self::$ipQueryError) {
            $bakendSuccess = $this->GetBakData();
            switch ($bakendSuccess) {
                case 0:
                    $this->HTMLtoBrowser_errorDBsite();
                    self::$ipQueryError = true;
                    break;
            
                case 1:
                    $this->HTMLtoBrowser_errActive();
                    self::$ipQueryError = true;
                    break;
				
                default:
                    break;		/* nulla	*/
            }
        }		

        /*	Uscita normale. 	*/
        if (!self::$ipQueryError) {
            switch (self::$sourceMaps) {
                case 1:         /*  OpenStreetMaps  */
                    $this->Uscita($this->HTML_OpenStreet());
                    break;
                case 2:         /*  Google maps */
                    $this->HTML_header();
                    $output = $this->HTML_contenuto();
                    $this->Uscita($output);
                default:
                    $this->Uscita(JText::_('ERROR #3'));
                    break;
            }
        }
    }

	/**
	 * $output  stringa inviata alla classe Joomla di passaggio per browser
	 * @param  $output string	 				 */
    private function Uscita($output) {
        ModIpTracker::$IpTrack_output = $output;
    }	
	
	
    private function GetBakData(){
        /*	Recupera la chiave	*/
        $db    = JFactory::getDBO();
        $query = $db->getQuery(true);
        $query->select('*');
        $query->from($db->quoteName('#__modules'));
        $query->where($db->quoteName('module').'='.$db->quote('mod_iptracker'));
		
        $db->setQuery($query);
        $rowResults = $db->loadAssoc();					/*	ritorna 1 riga	*/

        if ($rowResults == null){
        /*	errore no mod_iptracker installato. Grave errore database sito	*/
            return 0;
        }
	
        if (intval($rowResults['published']) == 0){
        /*	errore mod_iptracker non attivato	*/
            return 1;
        }
	
        $params = json_decode($rowResults['params']);
        self::$sourceMaps = $params->SourceMaps;
        self::$keyMap = $params->key_map;
		
        return 2;
    }
    
    private function HTML_OpenStreet() {
        $olHTML = $this->HTML_contenuto();
        $olJS = $this->JSOpenStreet();
        return $olHTML . $olJS;
    }
    
    private function JSOpenStreet() {
        /*	add a css file into template	*/
        $document = JFactory::getDocument();
        $document->addStyleSheet('/modules/mod_iptracker/icd/ol.css'); 
        
        $lat = self::$ipObj->lat;				/*	7	*/
        $lon = self::$ipObj->lon;
        $jsOL = <<<jsOL
<script src="/modules/mod_iptracker/icd/ol.js"></script>
<script>
var city = new ol.Feature({geometry: new ol.geom.Point(ol.proj.fromLonLat([{$lon}, {$lat}]))}); city.setStyle(new ol.style.Style({image: new ol.style.Icon(({src: '/modules/mod_iptracker/icd/marker-green.png', anchor: [0.5, 1]}))}));
var vectorSource = new ol.source.Vector({features: [city]});
var vectorLayer = new ol.layer.Vector({source: vectorSource});
var map = new ol.Map({layers: [new ol.layer.Tile({source: new ol.source.OSM()}),vectorLayer],target: 'map_canvas', view: new ol.View({center: ol.proj.fromLonLat([{$lon}, {$lat}]), zoom: 8})});
</script>    
jsOL;
        return $jsOL;
    }

	/**
	 * stringa HTML di contenuto
	 * @return string				  */
    private function HTML_contenuto(){
        $ip = self::$ipObj->query;				/*	0	*/
        $country = self::$ipObj->country;			/*	1	*/
        $countryCode = self::$ipObj->countryCode;		/*	2	*/
        $regionName = self::$ipObj->regionName;			/*	3	*/
        $region = self::$ipObj->region;				/*	4	*/
        $city = self::$ipObj->city;				/*	5	*/
        $lat = self::$ipObj->lat;				/*	7	*/
        $lon = self::$ipObj->lon;				/*	8	*/
        $timezone = self::$ipObj->timezone;			/*	9	*/
        $isp = self::$ipObj->isp;				/*	10	*/
        $org = self::$ipObj->org;				/*	11	*/
        $as = self::$ipObj->as;					/*	12	*/
        $edHost = self::$ipObj->edhost;				/*      13      */
		
        $info = JText::_('MOD_IPTRACKER_INFOV4V6');
        $cnty = JText::_('MOD_IPTRACKER__COUNTRY');
        $codC = JText::_('MOD_IPTRACKER_CODCONTY');
        $regg = JText::_('MOD_IPTRACKER___REGION');
        $codR = JText::_('MOD_IPTRACKER_CODREGIO');
        $n_cy = JText::_('MOD_IPTRACKER_____CITY');
        $lati = JText::_('MOD_IPTRACKER_LATITUDE');
        $long = JText::_('MOD_IPTRACKER_LONGITUD');
        $fuso = JText::_('MOD_IPTRACKER_FUSORARI');
        $orga = JText::_('MOD_IPTRACKER_ORGANIZA');		

        $contenuto = <<<CONTE
<div class="edB">
        <h3>{$info}</h3>
        <p><span>IP: </span>{$ip}
        <br>
        <span> Host: </span><span> {$edHost}</span></p>
        <p><span>{$cnty} </span>{$country}</p>
        <p><span>{$codC} </span>{$countryCode}</p>
        <p><span>{$regg} </span>{$regionName}</p>
        <p><span>{$codR} </span>{$region}</p>
        <p><span>{$n_cy} </span>{$city}</p>
        <p><span>{$lati} </span>{$lat}</p>
        <p><span>{$long} </span>{$lon}</p>
        <p><span>{$fuso} </span>{$timezone}</p>
        <p><span>ISP: </span>{$isp}</p>
        <p><span>{$orga} </span>{$org}</p>
        <p><span>AS nr/name: </span>{$as}</p>
</div>
<div id="map_canvas" class="edMaps"></div>
CONTE;
        return $contenuto;
    }


	/**
	* Inserisce file di Google e codice di avvio per la mappa.
	* @return string				 */
    private function HTML_header(){
		
        $lat = self::$ipObj->lat;
        $lon = self::$ipObj->lon;
        $titleMarker = self::$ipObj->query;
			
	/*	aggiunge Google maps file nella  head	*/
        (self::$keyMap != '') ? ($key = '&key='.self::$keyMap) : ($key = ''); 

        $document = JFactory::getDocument();
        $url = 'https://maps.googleapis.com/maps/api/js?v=3.exp'. $key;
        $document->addScript($url);
		
	/*	aggiunge lo script di avvio mappa	*/
        $header = <<<HEA
function IPT_gMapAvvio() {
    var mapCanvas = document.getElementById('map_canvas');
    var ptPos = new google.maps.LatLng({$lat}, {$lon});
    var mapOptions = {
        center: ptPos,
        zoom: 8,
        mapTypeId: google.maps.MapTypeId.ROADMAP
    };
    var map = new google.maps.Map(mapCanvas, mapOptions);
    var marker = new google.maps.Marker({
        position: ptPos,
        map: map,
        title: 'IP = {$titleMarker}'
    });
}
google.maps.event.addDomListener(window, 'load', IPT_gMapAvvio);
HEA;
		
        $document->addScriptDeclaration($header);
    }	
	

	/**
	 * database ip non risponde				 */
    private function HTMtoBrowser_noDb(){
        $info = JText::_('MOD_IPTRACKER_INFOV4V6');
        $nodb = JText::_('MOD_IPTRACKER_DB_OCCUP');
		
        $a = <<<HT
<div id="ed_captcha" class="edCaptcha">
<h3>{$info}</h3>
<h3 class="capRed">{$nodb}</h3>
</div>
HT;

        $this->Uscita($a);
    }	

	/**
	 * Query al database degli ip fallita per qualche ragione		 */
    private function HTMtoBrowser_failQuery(){
        $info = JText::_('MOD_IPTRACKER_INFOV4V6');
        $fail = JText::_('MOD_IPTRACKER_FAILQUER');
		
        $a = <<<HT
<div id="ed_captcha" class="edCaptcha">
<h3>{$info}</h3>
<h3 class="capRed">{$fail}</h3>
HT;

        $b = '';
        foreach (self::$ipObj as $key => $value){
            $pippo = <<<HHT
<p>{$key} = {$value}</p>
HHT;
            $b .= $pippo;
        }

        $c = <<<FTR
</div>
FTR;
        $this->Uscita($a . $b . $c);
    }
	
	
	
    private function HTMLtoBrowser_errorDBsite(){
        $info = JText::_('MOD_IPTRACKER_INFOV4V6');
        $erds = JText::_('MOD_IPTRACKER_ERRDBSIT');
            
        $a = <<<HT
<div id="ed_captcha" class="edCaptcha">
<h3>{$info}</h3>
<h2 class="capRed">{$erds}</h2>
</div>
HT;
        $this->Uscita($a);
    }
	
	
    private function HTMLtoBrowser_errActive(){
        $info = JText::_('MOD_IPTRACKER_INFOV4V6');
        $eram = JText::_('MOD_IPTRACKER_ERR_ATTI');
		
        $a = <<<HT
<div id="ed_captcha" class="edCaptcha">
<h3>{$info}</h3>
<h2 class="capRed">{$eram}</h2>
</div>
HT;
        $this->Uscita($a);
    }

}



/*	------		Main Script 	----------	*/
	
    if (null == session_id()) {session_start();}
	
	
/*	add a css file into template	*/
    $document = JFactory::getDocument();
    $url = '/modules/mod_iptracker/icd/ipTracker.css';	
    $document->addStyleSheet($url);
	
	
/*	Test captcha	*/
    $captcha = new IPT_CAPTCHA();
	
	
/*	esito test captcha	*/	
    switch (IPT_CAPTCHA::$test_CaptchaStatus) {
        case 1:
            $captcha->GetCaptcha4();				/*	costruisce captcha. nuovo	*/
            if ($captcha::$test_GD){
                $captcha->HTMtoBrowser_captcha();	/*  invia al browser ed esce	*/
            }
            else {
                $captcha->HTMLtoBrowser_noGD();		/*	msg supporto GD assente	*/
            }
            ModIpTracker::$continue = false;
            break;
        case 2:
            ModIpTracker::$continue = true;
            break;					/*	test superato. prosegue dopo switch	*/
        case 3:
            $captcha->GetCaptcha4();			/*	costruisce captcha. digits errati	*/
            $captcha->HTMtoBrowser_captcha();		/*  invia al browser ed esce	*/
            ModIpTracker::$continue = false;
            break;
        default:
            $captcha->HTMtoBrowser_stop();		/* msg stop ed esce. valore 4	*/
            ModIpTracker::$continue = false;
            break;
    }
	
	
/* test IP	*/
    if (ModIpTracker::$continue == true){
        if($captcha->Test_IP() != true){
            ModIpTracker::$continue = false;
            $captcha->GetCaptcha4();			/*	test fallito. costruisce captcha	*/
            $captcha->HTMtoBrowser_captcha();		/*  invia al browser ed esce	*/
        }
    }	
	
    unset($captcha);
	
	
/* infine, traccia IP	*/
    if (ModIpTracker::$continue == true){
        $ip = new IPT_MAPVISITE_CAPTHA();
    }
	